//===============================================================================
// FILENAME: main.c
//
// DESCRIPTION: The file when the main loop (with menu) is implemented
// NOTE: 
//
// (c) Entry_AR1755, 2005
//     Philips 2005 ARM Design Contest
//===============================================================================

//20-27


#include <LPC213x.H>     // LPC210x definitions/
#define XMAX  64         //bytes per line	 (horizontalal resolution)

//from VideoController.c
extern unsigned short cntL[];       //horiz. line counter structure
extern unsigned int VideoArray[];	//frame buffer
extern void VideoController_Start(char);

//from VideoGUI.c
extern void GUI_DrawRect();
extern unsigned int GUI_PrintChar(unsigned int, char);
extern unsigned int GUI_PrintBigDigit(unsigned int,char);
extern unsigned int GUI_PrintBigInteger(unsigned int, unsigned int, char, char);
extern void GUI_PrintStr(unsigned int, unsigned int, char*);
extern void GUI_DrawWallpaper();
extern void GUI_ClrScr();
extern void GUI_Invert(unsigned int, unsigned int, char, char, char);
extern void GUI_RestoreWallpaper(unsigned int, unsigned int, char, char, char);
extern void GUI_DrawPixel(unsigned int, unsigned int);
extern void GUI_DrawLine(unsigned int, unsigned int, unsigned int, unsigned int);

//from Oscilloscope.c
extern void ADC_Start();
extern void GetVoltages();
extern void GetVoltages_ShowTrigLevel(unsigned int);
extern unsigned int GetVoltages_CalculateAddr();
extern unsigned int GetVoltages_TrigLevel;
extern unsigned int GetVoltages_ShiftLevel;
extern unsigned char GetKey();
extern void NewHScale(char);
extern void DrawPlot(unsigned char, unsigned char *, unsigned char *);
extern void FLASH_Save(unsigned char);
extern void FLASH_Restore(unsigned char);
extern void Visualization();
extern unsigned int Level;   //Trigger level and flags
extern unsigned char Menu;   //Menu level 0--normal operating, 1--"Store", 2--"XXX"


unsigned char s;
unsigned char index=0;       //Menu's index	for choice
unsigned char Optimal;       //optimal line for begining of DrawPlot()

unsigned int i; //count
unsigned int j=1; //count
void menu2(void);

//------------------------------ Main body ---------------------------------

int main (void)  {
//---------------------------- Initialization -------------------------------
//start video generating
if(IOPIN0&0x800000) {VideoController_Start(2); Optimal=190;}//if NTSC
             else	{VideoController_Start(1); Optimal=224;}//if PAL
//start data collecting
ADC_Start();
s=GetKey();//blanc reading

start:
//GUI_ClrScr();
GUI_DrawWallpaper();
GUI_DrawRect();
GUI_PrintStr(0,0, "    \5  TV-based scope (v1.0)  \4        ARM Design Contest 2005    ");
GUI_PrintStr(20,4, "\5 Input 1\2\4 Input 2\2\4 Input 3\2\4 Input 4\2\4 Input 5\2\4\4");

GUI_PrintStr(2,47, "\5   Vertical   \4");
GUI_PrintStr(3,47, "\5     Scale    \4");
GUI_PrintStr(4,47, "\5 \4            \5 \4");
GUI_PrintStr(5,47, "\5 \4            \5 \4");
GUI_PrintStr(6,47, "\5 \4      mV/div\5 \4");
GUI_PrintStr(7,47, "\5 \4            \5 \4");
GUI_PrintStr(8,47, "\5              \4");
GUI_PrintBigInteger((unsigned int)VideoArray+(48+XMAX*50), 500, 3, 0);

GUI_PrintStr(11,47, "\5  Horizontal  \4");
GUI_PrintStr(12,47, "\5     Scale    \4");
GUI_PrintStr(13,47, "\5 \4            \5 \4");
GUI_PrintStr(14,47, "\5 \4            \5 \4");
GUI_PrintStr(15,47, "\5 \4      mS/div\5 \4");
GUI_PrintStr(16,47, "\5 \4            \5 \4");
GUI_PrintStr(17,47, "\5 Down      Up \4");
NewHScale(2);	//show current Horizontal Scale

//clear first digit positions in voltage windows
for (i=0; i<5; i++) GUI_PrintBigDigit((unsigned int)VideoArray+i*12+(4+XMAX*210),10);

//show Trigger Level's cursor
GetVoltages_ShowTrigLevel(GetVoltages_CalculateAddr());

while(1) {
//------------------------------ main loop -------------------------------

while (cntL[0]<=Optimal) {}; //wait the specific TV line  (224 is optimal for PAL)
Visualization();
while (cntL[0]>Optimal) {};  //wait the specific TV line
GetVoltages();
//============================= global menu ==============================
s=GetKey();
switch (Menu){
//------------------------------ main menu -------------------------------
case 0: {switch (s){//S4 -- "Store"
                    case 0x81: {Menu=1;
					            GUI_PrintStr(18,4, "\3\6 Store: Exit  1  2  3  4  5  6  7  8  9 10  ");
								GUI_Invert(18,14-2, 6, 2+2, 10); //show cursor
								index=0;
								break;}
                    //S2 -- "Down"
                    case 0x82: {NewHScale(255); break;}
                    //S3 -- "Up"
                    case 0x84: {NewHScale(1); break;}
                    //S5 -- "F"
                    case 0x88: {NewHScale(2); index=1; menu2(); index=0; goto start;
								break; }
                    }//switch (s)
		 break;}
//----------------------------- "Store" menu -----------------------------
case 1: {switch (s){//S4 -- "Store"
                    case 0x81: {if(index!=0)  {FLASH_Save(index);}; //here store operation
								NewHScale(0);	//show current Horizontal Scale
								Menu=0; GUI_RestoreWallpaper(18, 4, 6, 56, 10);	//exit to main menu
								break;}
                    //S2 -- "Down"
                    case 0x82: {GUI_Invert(18,14+index*3-2*(index==0), 6, 2+2*(index==0), 10);//hide cursor
					            if(index>0) index--; else index=10;
					            GUI_Invert(18,14+index*3-2*(index==0), 6, 2+2*(index==0), 10);//show cursor
								FLASH_Restore(index); //show saved graph
								break;}
                    //S3 -- "Up"
                    case 0x84: {GUI_Invert(18,14+index*3-2*(index==0), 6, 2+2*(index==0), 10);//hide cursor
					            if(index<10) index++;  else index=0;
					            GUI_Invert(18,14+index*3-2*(index==0), 6, 2+2*(index==0), 10);//show cursor
								FLASH_Restore(index); //show saved graph
								break;}
                    //S5 -- "F"
                    case 0x88: {//if(index==0) {NewHScale(0); Menu=0; GUI_RestoreWallpaper(18, 4, 6, 56, 10);} //exit to main menu
								//        else {Menu=2; GUI_PrintStr(18,4, "\3\6 View:");}	   //or to "View" menu
								break;}
                    }//switch (s)
         break;}

}//switch (Menu)

}//while(1)

}//main
//------------------------------- end of main ------------------------------




//------------------------------- Screen saver ------------------------------
#define MAX  8
#define M  400000000 
int x[MAX]={-M,M,M,-M,  -M,M,M,-M};
int y[MAX]={M,M,-M,-M,  M,M,-M,-M};
int z[MAX]={M,M,M,M,  -M,-M,-M,-M};

void ScreenSaver(void)
{
int i,j;

GUI_ClrScr();
while(GetKey()!=0x88) {

for(i=0;i<MAX;i++) {
x[i]=x[i]+(y[i]>>5)+(z[i]>>6);
y[i]=y[i]-(x[i]>>5)          +(z[i]>>10);
z[i]=z[i]          -(x[i]>>6)-(y[i]>>10);
}//for i

for(j=0;j<2;j++){
   for(i=0;i<(MAX/2);i++) {//Cube
       GUI_DrawLine((x[i]>>22)+256, (y[i]>>23)+120, (x[(i+1)&3]>>22)+256, (y[(i+1)&3]>>23)+120);
       GUI_DrawLine((x[i]>>22)+256, (y[i]>>23)+120, (x[i+4]>>22)+256, (y[i+4]>>23)+120);
       GUI_DrawLine((x[i+4]>>22)+256, (y[i+4]>>23)+120, (x[((i+1)&3)+4]>>22)+256, (y[((i+1)&3)+4]>>23)+120);
       }//for i

       if(j==0) {while (cntL[0]<=230); while (cntL[0]>230);} 
   }//for j
}//while

}


//------------------------------ "F" (Function) menu ------------------------------
void menu2 (void)
{
menu2_:
GUI_DrawWallpaper();
GUI_PrintStr(5, 17, "\5                              \4");
GUI_PrintStr(6 ,17, "\5 \4                            \5 \4");
GUI_PrintStr(7, 17, "\5 \4 1. Screen Saver            \5 \4");
GUI_PrintStr(8, 17, "\5 \4 2. Oscilloscope            \5 \4");
GUI_PrintStr(9, 17, "\5 \4                            \5 \4");
GUI_PrintStr(10,17, "\5 \4    Under construction:     \5 \4");
GUI_PrintStr(11,17, "\5 \4   ---------------------    \5 \4");
GUI_PrintStr(12,17, "\5 \4 3. Spectrum Analizer       \5 \4");
GUI_PrintStr(13,17, "\5 \4 4. Logic Analizer          \5 \4");
GUI_PrintStr(14,17, "\5 \4 5. ECG Scope               \5 \4");
GUI_PrintStr(15,17, "\5 \4 6. Vector ECG Scope        \5 \4");
GUI_PrintStr(16,17, "\5 \4 7. Polygraph (Lie Detector)\5 \4");
GUI_PrintStr(17,17, "\5 \4 8. Music Tools Tuning      \5 \4");
GUI_PrintStr(18,17, "\5 \4 9. Tennis (game)           \5 \4");
GUI_PrintStr(19,17, "\5 \4 10. ...                    \5 \4");
GUI_PrintStr(20,17, "\5                              \4");
GUI_Invert(index+7,19, 0, 26, 10);//show cursor
while(s!=0xFF) {
while (cntL[0]<=Optimal) {}; //wait the specific TV line
while (cntL[0]>Optimal) {};  //wait the specific TV line
s=GetKey();
switch (s)         {//S4 -- "Store"
                    case 0x81: {
								break;}
                    //S2 -- "Down"
                    case 0x82: {GUI_Invert(index+7,19, 0, 26, 10);//hide cursor
					            if(index<1) index++;
					            GUI_Invert(index+7,19, 0, 26, 10);//show cursor
								break;}
                    //S3 -- "Up"
                    case 0x84: {GUI_Invert(index+7,19, 0, 26, 10);//hide cursor
					            if(index>0) index--;
					            GUI_Invert(index+7,19, 0, 26, 10);//show cursor
								break;}
                    //S5 -- "F"
                    case 0x88: {if(index==0) {ScreenSaver(); goto menu2_;}
					                   else  s=0xFF;//exit to main menu
								break;}
                    }//switch (s)
}//while
}
//---------------------------------- end of main.c -----------------------------
